<id>
vReportBoard Mod
</id>

<version>
0.95
</version>

<mod info>
Posts reported posts into a specific board, instead of sending mails.
</mod info>

<author>
Valodim
</author>

<homepage>
mugenguild.com
</homepage>



<edit file>
index.php
</edit file>


<search for>
		'smileys' => array('ManageSmileys.php', 'ManageSmileys'),
</search for>

<add after>
		'solve' => array('SendTopic.php', 'SolveTopic'),
</add after>



<edit file>
$sourcedir/SendTopic.php
</edit file>


<search for>
function ReportToModerator2()
{
</search for>

<add after>
/*
</add after>


<search for>
	// Back to the board! (you probably don't want to see the post anymore..)
	redirectexit('board=' . $board . '.0');
</search for>

<add after>
*/

	global $txt, $scripturl, $db_prefix, $topic, $board, $board_info, $user_info, $ID_MEMBER, $modSettings, $sourcedir, $language;

	// Check their session... don't want them redirected here without their knowledge.
	checkSession();

	// You must have the proper permissions!
	isAllowedTo('report_any');

	include_once($sourcedir . '/Subs-Post.php');

        if(empty($modSettings['report_board']))
                fatal_lang_error('rtm_noboard');

	if($board == $modSettings['report_board'])
		fatal_lang_error('rtm_reportboard');

	// Get the basic topic information, and make sure they can see it.
	$_POST['msg'] = (int) $_POST['msg'];

	// fetch quote and stuff
	$request = db_query("
		SELECT m.ID_MEMBER, m.posterName, mem.realName, m.posterTime, m.subject, m.body
		FROM {$db_prefix}messages AS m
			LEFT JOIN {$db_prefix}members AS mem ON (m.ID_MEMBER = mem.ID_MEMBER)
		WHERE m.ID_MSG = $_POST[msg]
			AND m.ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
		fatal_lang_error('smf232');
	list ($member, $posterName, $realName, $mdate, $form_subject, $form_message) = mysql_fetch_row($request);
	mysql_free_result($request);

	if ($member == $ID_MEMBER)
		fatal_lang_error('rtm_not_own', false);

	$form_message = preg_replace('~<br(?: /)?' . '>~i', "\n", $form_message);

	// Remove any nested quotes, if necessary.
	if (!empty($modSettings['removeNestedQuotes']))
		$form_message = preg_replace(array('~\n?\[quote.*?\].+?\[/quote\]\n?~is', '~^\n~', '~\[/quote\]~'), '', $form_message);
	// and replace all img tgs by url tags
	$form_message = preg_replace('/\[img\](.+?)\[\/img\]/is', '[url]\1[/url]', $form_message);
	// Add a quote string on the front and end.
	$form_message = '[quote author=' . $posterName . ' link=topic=' . $topic . '.msg' . $_POST['msg'] . '#msg' . $_POST['msg'] . ' date=' . $mdate . ']' . "\n" . $form_message . "\n" . '[/quote]';

        // some parsing
	$message = htmlspecialchars($_POST['comment'], ENT_QUOTES) . "\n\n" . $form_message;
	preparsecode($message);

	// set up all options
	$msgOptions = array(
		'id' => 0,
		'subject' => '[' . addslashes($board_info['name']) . '] ' . addslashes($form_subject),
		'body' => $message,
		'icon' => 'unsolved',
		'smileys_enabled' => true,
		'attachments' => array(),
	);
	$topicOptions = array(
		'id' => 0,
		'board' => $modSettings['report_board'],
		'poll' => null,
		'lock_mode' => null,
		'sticky_mode' => null,
		'mark_as_read' => true,
	);
	$posterOptions = array(
		'id' => $ID_MEMBER,
		'name' => $user_info['username'],
		'email' => $user_info['email'],
		// do reports count as posts?
		'update_post_count' => $modSettings['report_count'] != 0,
	);

	// and post!
	createPost($msgOptions, $topicOptions, $posterOptions);

	// Back to the board! (you probably don't want to see the post anymore..)
	redirectexit('board=' . $board . '.0');

}

// Solves/Unsolves a topic.
function SolveTopic()
{
	global $db_prefix, $modSettings, $board, $topic, $sourcedir;

	// solving only in the report board! we don't need a permission check, everyone who has access here can solve.
	if($board != $modSettings['report_board'])
		fatal_lang_error('rtm_solveoutside');

	// Just quit if there's no topic to lock.
	if (empty($topic))
		fatal_lang_error(472, false);

	// It's a toggle action, so get current status
	$request = db_query("
		SELECT m.ID_MSG, m.icon
		FROM {$db_prefix}topics as t, {$db_prefix}messages as m
		WHERE t.ID_TOPIC = $topic
			AND m.ID_MSG = t.ID_FIRST_MSG
		LIMIT 1", __FILE__, __LINE__);
	list ($msg, $icon) = mysql_fetch_row($request);
	mysql_free_result($request);

	$icon = ($icon == 'unsolved') ? 'solved' : 'unsolved';

	// Actually lock the topic in the database with the new value.
	db_query("
		UPDATE {$db_prefix}messages
		SET icon = '$icon'
		WHERE ID_MSG = $msg
		LIMIT 1", __FILE__, __LINE__);

	// Always log this.
	logAction('solve', array('topic' => $topic));

	// Back to the board!
	redirectexit('board=' . $board . '.0');

</add after>



<edit file>
$sourcedir/Display.php
</edit file>


<search for>
	$context['can_remove_post'] = allowedTo('delete_any') || (allowedTo('delete_replies') && $context['user']['started']);
</search for>

<add after>

	// everyone can solve inside the report board. it's not meant to be public, anyways.
	$context['can_solve'] = ($board == $modSettings['report_board']);
</add after>



<edit file>
$sourcedir/MessageIndex.php
</edit file>


<search for>
			" . (!empty($modSettings['enableStickyTopics']) ? 't.isSticky' . ($fake_ascending ? '' : ' DESC') . ',
</search for>

<add after>
                        ' : '') . ($board == $modSettings['report_board'] ? "mf.icon = 'unsolved'" . ($fake_ascending ? '' : ' DESC') . ',
</add after>



<edit file>
$sourcedir/ModSettings.php
</edit file>


<search for>
			array('check', 'enableReportPM'),
</search for>

<add after>
			array('int', 'report_board'),
</add after>



<edit file>
$themedir/Display.template.php
</edit file>

<search for>
	if ($context['can_merge'])
		$moderationButtons[] = '<a href="' . $scripturl . '?action=mergetopics;board=' . $context['current_board'] . '.0;from=' . $context['current_topic'] . '">' . ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/merge.gif" alt="' . $txt['smf252'] . '" border="0" />' : $txt['smf252']) . '</a>';
</search for>

<add after>
	if ($context['can_solve'])
		$moderationButtons[] = '<a href="' . $scripturl . '?action=solve;topic=' . $context['current_topic'] . '">' . ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/solve.gif" alt="' . $txt['report_solve'] . '" border="0" />' : $txt['report_solve']) . '</a>';
</add after>



<edit file>
$themedir/languages/index.english.php
</edit file>


<search for>
$txt['smf315'] = 'Use this function to inform the moderators and administrators of an abusive or wrongly posted message.<br /><i>Please note that your email address will be revealed to the moderators if you use this.</i>';
</search for>

<replace>
$txt['smf315'] = 'Use this function to inform the moderators and administrators of an abusive or wrongly posted message.';
$txt['report_solve'] = 'Solve/Unsolve';
</replace>



<edit file>
$themedir/languages/ModSettings.english.php
</edit file>


<search for>
$txt['enableReportPM'] = 'Enable reporting of personal messages';
</search for>

<add after>
$txt['report_board'] = 'Report Board (id)';
</add after>



<edit file>
$themedir/languages/Errors.english.php
</edit file>


<search for>
$txt['rtm_not_own'] = 'You can\'t report your own post to the moderator, that doesn\'t make sense!';
</search for>

<add after>
$txt['rtm_noboard'] = 'Reporting is currently disabled. Please try again later, or contact the forum administrator.';
$txt['rtm_solveoutside'] = 'You cannot solve topics outside the report board.';
$txt['rtm_reportboard'] = 'You cannot report a post from the report board.';
</add after>



<edit file>
$themedir/languages/Help.english.php
</edit file>


<search for>
$helptxt['enableReportPM'] = 'This option allows your users to report personal messages they receive to the administration team. This may be useful in helping to track down any abuse of the personal messaging system.';
</search for>

<add after>
$helptxt['report_board'] = 'The board to be used for reported posts. Should be a dedicated board, to keep stuff tidy.<br /><br /><b>If this is 0, post reporting will be disabled!!</b>';
</add after>
